<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { computed, inject, onMounted, onUnmounted } from 'vue';
import { storeToRefs } from 'pinia';
import { useChatStore } from '@/stores/chat';
import { request } from '@/lib/request';
import { useI18n } from 'vue-i18n';

const { t } = useI18n();
const $t = t;

const chatStore = useChatStore();
const { tokensUsed, tokenQuota } = storeToRefs(chatStore);

const configuration = inject<any>('configuration');

const percentage = computed(() => Math.round((tokensUsed.value / tokenQuota.value) * 100));
const background = computed(() => {
  if (percentage.value > 80) return 'from-green-500 to-green-100';
  if (percentage.value > 60) return 'from-lime-500 to-lime-100';
  if (percentage.value > 40) return 'from-yellow-500 to-yellow-100';
  if (percentage.value > 20) return 'from-amber-500 to-amber-100';
  if (percentage.value > 10) return 'from-orange-500 to-orange-100';
  return 'from-red-500 to-red-100';
});

const barColor = computed(() => {
  if (percentage.value > 80) return 'bg-green-600';
  if (percentage.value > 60) return 'bg-lime-600';
  if (percentage.value > 40) return 'bg-yellow-600';
  if (percentage.value > 20) return 'bg-amber-600';
  if (percentage.value > 10) return 'bg-orange-600';
  return 'bg-red-600';
});

const barColorShadow = computed(() => {
  if (percentage.value > 80) return 'rgb(21 128 61)' //'bg-green-700';
  if (percentage.value > 60) return 'rgb(77 124 15)'//'bg-lime-700';
  if (percentage.value > 40) return 'rgb(161 98 7)'//'bg-yellow-700';
  if (percentage.value > 20) return 'rgb(180 83 9)'//'bg-amber-700';
  if (percentage.value > 10) return 'rgb(194 65 12)'//'bg-orange-700';
  return 'rgb(185 28 28)';
});

let intervalId: any;
onMounted(async () => {
  const result = await request('GET', configuration.apiServer + "/api/ai/tokens", undefined, undefined, false, true);
  tokenQuota.value = result.tokenQuota;
  tokensUsed.value = tokenQuota.value - result.tokensUsed;
  updateTokens();
  intervalId = setInterval(updateTokens, 60000);

});

onUnmounted(() => {
  if (intervalId) {
    clearInterval(intervalId);
  }
});

const updateTokens = async () => {
  const result = await request('GET', configuration.apiServer + "/api/ai/tokens", undefined, undefined, false, true);
  if (result.success && (tokenQuota.value - result.tokensUsed) !== tokensUsed.value) {
    tokenQuota.value = result.tokenQuota;
    const newTokensUsed = tokenQuota.value - result.tokensUsed;
    const diff = newTokensUsed - tokensUsed.value;
    const stepSize = Math.abs(diff) / 100;
    for (let i = 0; i <= Math.abs(diff); i += stepSize) {
      if (diff > 0) {
        if (tokensUsed.value - stepSize < tokenQuota.value)
          tokensUsed.value += stepSize;
      } else {
        if (tokensUsed.value - stepSize > 0)
          tokensUsed.value -= stepSize;
      }
      await new Promise(resolve => setTimeout(resolve, 10));
    }
    tokensUsed.value = newTokensUsed;
  }
};

function formatTokenAmount(amount: number) {
  if (amount >= 1000000) {
    return (amount / 1000000).toFixed(2) + ' ' + $t('ai.overview.token.units.mio');
  } else if (amount >= 1000) {
    return (amount / 1000).toFixed(3);
  } else {
    return amount.toString();
  }
}


</script>
<template>
  <div :class="background"
    class="bg-gradient-to-br from-50% h-24 text-white rounded-lg p-4 flex flex-col justify-between select-none">
    <p class="flex flex-row justify-between pb-1.5">
    <div class="flex flex-row gap-2"><i class="ri-coins-line"></i>{{ $t('ai.overview.token.label') }}</div>
    <Tooltip :tooltip="$t('ai.overview.token.tooltip')"><button class=""><i class="ri-information-2-line"></i></button>
    </Tooltip>
    </p>
    <div class="w-full bg-white h-6 rounded-md p-0.5 justify-center">
      <div :class="barColor" class="h-5 rounded-md token-bar" :style="{ width: percentage + '%' }"
        style="transition: width 1s ease;" v-if="tokensUsed > 0"></div>
      <div class="h-5 rounded-md w-0 transparent" v-else></div>
      <div class="text-xs font-medium relative bottom-5 pt-0.5 w-full text-black text-center flex justify-center"> <span
          class="w-fit text-white font-semibold flex text-xs " style="filter: url(#text-shadow)">
          <Tooltip :tooltip="(tokensUsed > 0 ? tokensUsed : 0).toLocaleString() + ' ' + $t('ai.overview.token.used.available')"
            :offset="5">{{ formatTokenAmount(tokensUsed > 0 ? tokensUsed : 0) }} </Tooltip> &nbsp;&nbsp; /&nbsp;&nbsp; {{
              formatTokenAmount(tokenQuota) }}
        </span></div>

      <!--Shadow if bar is too short to cover text-bg -->
      <svg width="0" height="0">
        <defs>
          <filter id="text-shadow" width="200%" height="200%">
            <feMorphology operator="dilate" in="SourceAlpha" radius="2" result="enlarge" />
            <feFlood :flood-color="barColorShadow" flood-opacity="0.8" result="color" />
            <feComposite in="color" in2="enlarge" operator="in" result="outline" />
            <feGaussianBlur in="outline" stdDeviation="1" result="blurred-outline" />
            <feMerge>
              <feMergeNode in="blurred-outline" />
              <feMergeNode in="SourceGraphic" />
            </feMerge>
          </filter>
        </defs>
      </svg>
    </div>
    <div class="text-center w-full">
      <span class="tracking-wider" style="font-size:11px;"
        v-if="tokensUsed > 0">{{ $t('ai.overview.token.used.percentage.available', [percentage]) }}</span>
      <span class="tracking-wider font-bold" style="font-size:12px;"
        v-else>{{ $t('ai.overview.token.used.noAvailable') }}</span>
    </div>

  </div>
</template>
